#ifndef GLOBAL_VALUES_H
#define GLOBAL_VALUES_H

//shader variables
#include "rts_glShaderProgram.h"
#include "rts_glShaderObject.h"
#include "VolumeShaderStruct.h"
void AttachShaderVariables();
void SetRenderSource();
void ReloadShaders();
void CreateShader(string filename);
extern vector<VolumeShader> ShaderList;
extern int SelectedShader;


//texture variables
#include "rts_glTextureMap.h"
#include "VolumeDataStruct.h"
#include "TextureDataStruct.h"
extern rts_glTextureMap VolumeTexture;
void CreateAutoVolume();
int LoadRawVolume(VolumeData &newVolume);
int LoadImages(VolumeData &newVolume);
int LoadTexture(TextureData &newTexture);
extern vector<VolumeData> VolumeList;
extern vector<TextureData> TextureList;


//scene variables
#include "rtsCamera.h"
#include "VolumeSourceStruct.h"
extern vector<VolumeSource> SourceList;
extern float gpVolSize[3];
extern float gpCropMin[3];
extern float gpCropMax[3];
extern int SelectedSource;
extern int RenderSource;
extern bool RenderSources;
extern float StepSize;
void DrawCube();
void DrawLights();

//project variables
void SaveProject(string filename);
void LoadProject(string filename);

//transfer function variables
void CreateHistogram(int bins, float& minX, float& maxX, float& minY, float& maxY);

#endif